Module javafx.graphics
Package javafx.scene.layout

# Class FlowPane

java.lang.Object
javafx.scene.Node
javafx.scene.Parent
javafx.scene.layout.Region
javafx.scene.layout.Pane
javafx.scene.layout.FlowPane

All Implemented Interfaces:
  `Styleable`, `EventTarget`

public class FlowPane extends Pane
FlowPane lays out its children in a flow that wraps at the flowpane's boundary.

A horizontal flowpane (the default) will layout nodes in rows, wrapping at the flowpane's width. A vertical flowpane lays out nodes in columns, wrapping at the flowpane's height. If the flowpane has a border and/or padding set, the content will be flowed within those insets.

FlowPane's prefWrapLength property establishes its preferred width (for horizontal) or preferred height (for vertical). Applications should set prefWrapLength if the default value (400) doesn't suffice. Note that prefWrapLength is used only for calculating the preferred size and may not reflect the actual wrapping dimension, which tracks the actual size of the flowpane.

The alignment property controls how the rows and columns are aligned within the bounds of the flowpane and defaults to Pos.TOP_LEFT. It is also possible to control the alignment of nodes within the rows and columns by setting rowValignment for horizontal or columnHalignment for vertical.

Example of a horizontal flowpane:

         Image images[] = { ... };
         FlowPane flow = new FlowPane();
         flow.setVgap(8);
         flow.setHgap(4);
         flow.setPrefWrapLength(300); // preferred width = 300
         for (int i = 0; i < images.length; i++) {
             flow.getChildren().add(new ImageView(image[i]);
         }

Example of a vertical flowpane:

         FlowPane flow = new FlowPane(Orientation.VERTICAL);
         flow.setColumnHalignment(HPos.LEFT); // align labels on left
         flow.setPrefWrapLength(200); // preferred height = 200
         for (int i = 0; i < titles.size(); i++) {
             flow.getChildren().add(new Label(titles[i]);
         }

FlowPane lays out each managed child regardless of the child's visible property value; unmanaged children are ignored for all layout calculations.

FlowPane may be styled with backgrounds and borders using CSS. See `Region` superclass for details.

## Resizable Range

A flowpane's parent will resize the flowpane within the flowpane's resizable range during layout. By default the flowpane computes this range based on its content as outlined in the tables below.

Horizontal
| width | height
minimum | left/right insets plus largest of children's pref widths | top/bottom insets plus height required to display all children at their preferred heights when wrapped at a specified width
preferred | left/right insets plus prefWrapLength | top/bottom insets plus height required to display all children at their pref heights when wrapped at a specified width
maximum | Double.MAX_VALUE | Double.MAX_VALUE

Vertical
| width | height
minimum | left/right insets plus width required to display all children at their preferred widths when wrapped at a specified height | top/bottom insets plus largest of children's pref heights
preferred | left/right insets plus width required to display all children at their pref widths when wrapped at the specified height | top/bottom insets plus prefWrapLength
maximum | Double.MAX_VALUE | Double.MAX_VALUE

A flowpane's unbounded maximum width and height are an indication to the parent that it may be resized beyond its preferred size to fill whatever space is assigned to it.

FlowPane provides properties for setting the size range directly. These properties default to the sentinel value Region.USE_COMPUTED_SIZE, however the application may set them to other values as needed:

         flowPane.setMaxWidth(500);

Applications may restore the computed values by setting these properties back to Region.USE_COMPUTED_SIZE.

FlowPane does not clip its content by default, so it is possible that children's bounds may extend outside its own bounds if a child's pref size is larger than the space flowpane has to allocate for it.

Since:
  JavaFX 2.0

## Property Summary

Properties
Type
Property
Description
`final ObjectProperty<Pos>`
`alignment`
The overall alignment of the flowpane's content within its width and height.
`final ObjectProperty<HPos>`
`columnHalignment`
The horizontal alignment of nodes within each column of a vertical flowpane.
`final DoubleProperty`
`hgap`
The amount of horizontal space between each node in a horizontal flowpane or the space between columns in a vertical flowpane.
`final ObjectProperty<Orientation>`
`orientation`
The orientation of this flowpane.
`final DoubleProperty`
`prefWrapLength`
The preferred width where content should wrap in a horizontal flowpane or the preferred height where content should wrap in a vertical flowpane.
`final ObjectProperty<VPos>`
`rowValignment`
The vertical alignment of nodes within each row of a horizontal flowpane.
`final DoubleProperty`
`vgap`
The amount of vertical space between each node in a vertical flowpane or the space between rows in a horizontal flowpane.

### Properties inherited from class javafx.scene.layout.Region

`background, border, cacheShape, centerShape, height, insets, maxHeight, maxWidth, minHeight, minWidth, opaqueInsets, padding, prefHeight, prefWidth, scaleShape, shape, snapToPixel, width`

### Properties inherited from class javafx.scene.Parent

`needsLayout`

### Properties inherited from class javafx.scene.Node

`accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

## Field Summary

### Fields inherited from class javafx.scene.layout.Region

`USE_COMPUTED_SIZE, USE_PREF_SIZE`

### Fields inherited from class javafx.scene.Node

`BASELINE_OFFSET_SAME_AS_HEIGHT`

## Constructor Summary

Constructors
Constructor
Description
`FlowPane()`
Creates a horizontal FlowPane layout with hgap/vgap = 0.
`FlowPane(double hgap, double vgap)`
Creates a horizontal FlowPane layout with the specified hgap/vgap.
`FlowPane(double hgap, double vgap, Node... children)`
Creates a horizontal FlowPane layout with the specified hgap/vgap.
`FlowPane(Orientation orientation)`
Creates a FlowPane layout with the specified orientation and hgap/vgap = 0.
`FlowPane(Orientation orientation, double hgap, double vgap)`
Creates a FlowPane layout with the specified orientation and hgap/vgap.
`FlowPane(Orientation orientation, double hgap, double vgap, Node... children)`
Creates a FlowPane layout with the specified orientation and hgap/vgap.
`FlowPane(Orientation orientation, Node... children)`
Creates a FlowPane layout with the specified orientation and hgap/vgap = 0.
`FlowPane(Node... children)`
Creates a horizontal FlowPane layout with hgap/vgap = 0.

## Method Summary

Modifier and Type
Method
Description
`final ObjectProperty<Pos>`
`alignmentProperty()`
The overall alignment of the flowpane's content within its width and height.
`static void`
`clearConstraints(Node child)`
Removes all flowpane constraints from the child node.
`final ObjectProperty<HPos>`
`columnHalignmentProperty()`
The horizontal alignment of nodes within each column of a vertical flowpane.
`protected double`
`computeMinHeight(double width)`
Computes the minimum height of this region.
`protected double`
`computeMinWidth(double height)`
Computes the minimum width of this region.
`protected double`
`computePrefHeight(double forWidth)`
Computes the preferred height of this region for the given width; Region subclasses should override this method to return an appropriate value based on their content and layout strategy.
`protected double`
`computePrefWidth(double forHeight)`
Computes the preferred width of this region for the given height.
`final Pos`
`getAlignment()`
Gets the value of the `alignment` property.
`static List<CssMetaData<? extends Styleable,?>>`
`getClassCssMetaData()`
`final HPos`
`getColumnHalignment()`
Gets the value of the `columnHalignment` property.
`Orientation`
`getContentBias()`
Returns the orientation of a node's resizing bias for layout purposes.
`List<CssMetaData<? extends Styleable,?>>`
`getCssMetaData()`
This method should delegate to `Node.getClassCssMetaData()` so that a Node's CssMetaData can be accessed without the need for reflection.
`final double`
`getHgap()`
Gets the value of the `hgap` property.
`static Insets`
`getMargin(Node child)`
Returns the child's margin constraint if set.
`final Orientation`
`getOrientation()`
Gets the value of the `orientation` property.
`final double`
`getPrefWrapLength()`
Gets the value of the `prefWrapLength` property.
`final VPos`
`getRowValignment()`
Gets the value of the `rowValignment` property.
`final double`
`getVgap()`
Gets the value of the `vgap` property.
`final DoubleProperty`
`hgapProperty()`
The amount of horizontal space between each node in a horizontal flowpane or the space between columns in a vertical flowpane.
`protected void`
`layoutChildren()`
Invoked during the layout pass to layout the children in this `Parent`.
`final ObjectProperty<Orientation>`
`orientationProperty()`
The orientation of this flowpane.
`final DoubleProperty`
`prefWrapLengthProperty()`
The preferred width where content should wrap in a horizontal flowpane or the preferred height where content should wrap in a vertical flowpane.
`void`
`requestLayout()`
Requests a layout pass to be performed before the next scene is rendered.
`final ObjectProperty<VPos>`
`rowValignmentProperty()`
The vertical alignment of nodes within each row of a horizontal flowpane.
`final void`
`setAlignment(Pos value)`
Sets the value of the `alignment` property.
`final void`
`setColumnHalignment(HPos value)`
Sets the value of the `columnHalignment` property.
`final void`
`setHgap(double value)`
Sets the value of the `hgap` property.
`static void`
`setMargin(Node child, Insets value)`
Sets the margin for the child when contained by a flowpane.
`final void`
`setOrientation(Orientation value)`
Sets the value of the `orientation` property.
`final void`
`setPrefWrapLength(double value)`
Sets the value of the `prefWrapLength` property.
`final void`
`setRowValignment(VPos value)`
Sets the value of the `rowValignment` property.
`final void`
`setVgap(double value)`
Sets the value of the `vgap` property.
`final DoubleProperty`
`vgapProperty()`
The amount of vertical space between each node in a vertical flowpane or the space between rows in a horizontal flowpane.

### Methods inherited from class javafx.scene.layout.Pane

`getChildren`

### Methods inherited from class javafx.scene.layout.Region

`backgroundProperty, borderProperty, cacheShapeProperty, centerShapeProperty, computeMaxHeight, computeMaxWidth, getBackground, getBorder, getHeight, getInsets, getMaxHeight, getMaxWidth, getMinHeight, getMinWidth, getOpaqueInsets, getPadding, getPrefHeight, getPrefWidth, getShape, getUserAgentStylesheet, getWidth, heightProperty, insetsProperty, isCacheShape, isCenterShape, isResizable, isScaleShape, isSnapToPixel, layoutInArea, layoutInArea, layoutInArea, layoutInArea, maxHeight, maxHeightProperty, maxWidth, maxWidthProperty, minHeight, minHeightProperty, minWidth, minWidthProperty, opaqueInsetsProperty, paddingProperty, positionInArea, positionInArea, prefHeight, prefHeightProperty, prefWidth, prefWidthProperty, resize, scaleShapeProperty, setBackground, setBorder, setCacheShape, setCenterShape, setHeight, setMaxHeight, setMaxSize, setMaxWidth, setMinHeight, setMinSize, setMinWidth, setOpaqueInsets, setPadding, setPrefHeight, setPrefSize, setPrefWidth, setScaleShape, setShape, setSnapToPixel, setWidth, shapeProperty, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, snapToPixelProperty, widthProperty`

### Methods inherited from class javafx.scene.Parent

`getBaselineOffset, getChildrenUnmodifiable, getManagedChildren, getStylesheets, isNeedsLayout, layout, lookup, needsLayoutProperty, queryAccessibleAttribute, requestParentLayout, setNeedsLayout, updateBounds`

### Methods inherited from class javafx.scene.Node

`accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, executeAccessibleAction, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInitialFocusTraversable, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookupAll, managedProperty, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, pressedProperty, pseudoClassStateChanged, relocate, removeEventFilter, removeEventHandler, requestFocus, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, toString, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface javafx.css.Styleable

`getStyleableNode`

## Property Details

### orientation

public final ObjectProperty<Orientation> orientationProperty
The orientation of this flowpane. A horizontal flowpane lays out children left to right, wrapping at the flowpane's width boundary. A vertical flowpane lays out children top to bottom, wrapping at the flowpane's height. The default is horizontal.

See Also:
  - `getOrientation()`
  - `setOrientation(Orientation)`
  - `orientationProperty()`

### hgap

public final DoubleProperty hgapProperty
The amount of horizontal space between each node in a horizontal flowpane or the space between columns in a vertical flowpane.

See Also:
  - `getHgap()`
  - `setHgap(double)`
  - `hgapProperty()`

### vgap

public final DoubleProperty vgapProperty
The amount of vertical space between each node in a vertical flowpane or the space between rows in a horizontal flowpane.

See Also:
  - `getVgap()`
  - `setVgap(double)`
  - `vgapProperty()`

### prefWrapLength

public final DoubleProperty prefWrapLengthProperty
The preferred width where content should wrap in a horizontal flowpane or the preferred height where content should wrap in a vertical flowpane.

This value is used only to compute the preferred size of the flowpane and may not reflect the actual width or height, which may change if the flowpane is resized to something other than its preferred size.

Applications should initialize this value to define a reasonable span for wrapping the content.

See Also:
  - `getPrefWrapLength()`
  - `setPrefWrapLength(double)`
  - `prefWrapLengthProperty()`

### alignment

public final ObjectProperty<Pos> alignmentProperty
The overall alignment of the flowpane's content within its width and height.

For a horizontal flowpane, each row will be aligned within the flowpane's width using the alignment's hpos value, and the rows will be aligned within the flowpane's height using the alignment's vpos value.

For a vertical flowpane, each column will be aligned within the flowpane's height using the alignment's vpos value, and the columns will be aligned within the flowpane's width using the alignment's hpos value.

See Also:
  - `getAlignment()`
  - `setAlignment(Pos)`
  - `alignmentProperty()`

### columnHalignment

public final ObjectProperty<HPos> columnHalignmentProperty
The horizontal alignment of nodes within each column of a vertical flowpane. The property is ignored for horizontal flowpanes.

See Also:
  - `getColumnHalignment()`
  - `setColumnHalignment(HPos)`
  - `columnHalignmentProperty()`

### rowValignment

public final ObjectProperty<VPos> rowValignmentProperty
The vertical alignment of nodes within each row of a horizontal flowpane. If this property is set to VPos.BASELINE, then the flowpane will always resize children to their preferred heights, rather than expanding heights to fill the row height. The property is ignored for vertical flowpanes.

See Also:
  - `getRowValignment()`
  - `setRowValignment(VPos)`
  - `rowValignmentProperty()`

## Constructor Details

### FlowPane

public FlowPane()
Creates a horizontal FlowPane layout with hgap/vgap = 0.

### FlowPane

public FlowPane(Orientation orientation)
Creates a FlowPane layout with the specified orientation and hgap/vgap = 0.

Parameters:
  `orientation` - the direction the tiles should flow & wrap

### FlowPane

public FlowPane(double hgap, double vgap)
Creates a horizontal FlowPane layout with the specified hgap/vgap.

Parameters:
  `hgap` - the amount of horizontal space between each tile
  `vgap` - the amount of vertical space between each tile

### FlowPane

public FlowPane(Orientation orientation, double hgap, double vgap)
Creates a FlowPane layout with the specified orientation and hgap/vgap.

Parameters:
  `orientation` - the direction the tiles should flow & wrap
  `hgap` - the amount of horizontal space between each tile
  `vgap` - the amount of vertical space between each tile

### FlowPane

public FlowPane(Node... children)
Creates a horizontal FlowPane layout with hgap/vgap = 0.

Parameters:
  `children` - The initial set of children for this pane.
Since:
  JavaFX 8.0

### FlowPane

public FlowPane(Orientation orientation, Node... children)
Creates a FlowPane layout with the specified orientation and hgap/vgap = 0.

Parameters:
  `orientation` - the direction the tiles should flow & wrap
  `children` - The initial set of children for this pane.
Since:
  JavaFX 8.0

### FlowPane

public FlowPane(double hgap, double vgap, Node... children)
Creates a horizontal FlowPane layout with the specified hgap/vgap.

Parameters:
  `hgap` - the amount of horizontal space between each tile
  `vgap` - the amount of vertical space between each tile
  `children` - The initial set of children for this pane.
Since:
  JavaFX 8.0

### FlowPane

public FlowPane(Orientation orientation, double hgap, double vgap, Node... children)
Creates a FlowPane layout with the specified orientation and hgap/vgap.

Parameters:
  `orientation` - the direction the tiles should flow & wrap
  `hgap` - the amount of horizontal space between each tile
  `vgap` - the amount of vertical space between each tile
  `children` - The initial set of children for this pane.
Since:
  JavaFX 8.0

## Method Details

### setMargin

public static void setMargin(Node child, Insets value)
Sets the margin for the child when contained by a flowpane. If set, the flowpane will layout it out with the margin space around it. Setting the value to null will remove the constraint.

Parameters:
  `child` - the child node of a flowpane
  `value` - the margin of space around the child

### getMargin

public static Insets getMargin(Node child)
Returns the child's margin constraint if set.

Parameters:
  `child` - the child node of a flowpane
Returns:
  the margin for the child or null if no margin was set

### clearConstraints

public static void clearConstraints(Node child)
Removes all flowpane constraints from the child node.

Parameters:
  `child` - the child node

### orientationProperty

public final ObjectProperty<Orientation> orientationProperty()
The orientation of this flowpane. A horizontal flowpane lays out children left to right, wrapping at the flowpane's width boundary. A vertical flowpane lays out children top to bottom, wrapping at the flowpane's height. The default is horizontal.

Returns:
  the orientation of this flowpane
See Also:
  - `getOrientation()`
  - `setOrientation(Orientation)`

### setOrientation

public final void setOrientation(Orientation value)
Sets the value of the `orientation` property.

Property description:
  The orientation of this flowpane. A horizontal flowpane lays out children left to right, wrapping at the flowpane's width boundary. A vertical flowpane lays out children top to bottom, wrapping at the flowpane's height. The default is horizontal.
Parameters:
  `value` - the value for the `orientation` property
See Also:
  - `getOrientation()`
  - `orientationProperty()`

### getOrientation

public final Orientation getOrientation()
Gets the value of the `orientation` property.

Property description:
  The orientation of this flowpane. A horizontal flowpane lays out children left to right, wrapping at the flowpane's width boundary. A vertical flowpane lays out children top to bottom, wrapping at the flowpane's height. The default is horizontal.
Returns:
  the value of the `orientation` property
See Also:
  - `setOrientation(Orientation)`
  - `orientationProperty()`

### hgapProperty

public final DoubleProperty hgapProperty()
The amount of horizontal space between each node in a horizontal flowpane or the space between columns in a vertical flowpane.

Returns:
  the amount of horizontal space between each node in a horizontal flowpane or the space between columns in a vertical flowpane
See Also:
  - `getHgap()`
  - `setHgap(double)`

### setHgap

public final void setHgap(double value)
Sets the value of the `hgap` property.

Property description:
  The amount of horizontal space between each node in a horizontal flowpane or the space between columns in a vertical flowpane.
Parameters:
  `value` - the value for the `hgap` property
See Also:
  - `getHgap()`
  - `hgapProperty()`

### getHgap

public final double getHgap()
Gets the value of the `hgap` property.

Property description:
  The amount of horizontal space between each node in a horizontal flowpane or the space between columns in a vertical flowpane.
Returns:
  the value of the `hgap` property
See Also:
  - `setHgap(double)`
  - `hgapProperty()`

### vgapProperty

public final DoubleProperty vgapProperty()
The amount of vertical space between each node in a vertical flowpane or the space between rows in a horizontal flowpane.

Returns:
  the amount of vertical space between each node in a vertical flowpane or the space between rows in a horizontal flowpane
See Also:
  - `getVgap()`
  - `setVgap(double)`

### setVgap

public final void setVgap(double value)
Sets the value of the `vgap` property.

Property description:
  The amount of vertical space between each node in a vertical flowpane or the space between rows in a horizontal flowpane.
Parameters:
  `value` - the value for the `vgap` property
See Also:
  - `getVgap()`
  - `vgapProperty()`

### getVgap

public final double getVgap()
Gets the value of the `vgap` property.

Property description:
  The amount of vertical space between each node in a vertical flowpane or the space between rows in a horizontal flowpane.
Returns:
  the value of the `vgap` property
See Also:
  - `setVgap(double)`
  - `vgapProperty()`

### prefWrapLengthProperty

public final DoubleProperty prefWrapLengthProperty()
The preferred width where content should wrap in a horizontal flowpane or the preferred height where content should wrap in a vertical flowpane.

This value is used only to compute the preferred size of the flowpane and may not reflect the actual width or height, which may change if the flowpane is resized to something other than its preferred size.

Applications should initialize this value to define a reasonable span for wrapping the content.

Returns:
  the preferred width where content should wrap in a horizontal flowpane or the preferred height where content should wrap in a vertical flowpane
See Also:
  - `getPrefWrapLength()`
  - `setPrefWrapLength(double)`

### setPrefWrapLength

public final void setPrefWrapLength(double value)
Sets the value of the `prefWrapLength` property.

Property description:
  The preferred width where content should wrap in a horizontal flowpane or the preferred height where content should wrap in a vertical flowpane.

  This value is used only to compute the preferred size of the flowpane and may not reflect the actual width or height, which may change if the flowpane is resized to something other than its preferred size.

  Applications should initialize this value to define a reasonable span for wrapping the content.

Parameters:
  `value` - the value for the `prefWrapLength` property
See Also:
  - `getPrefWrapLength()`
  - `prefWrapLengthProperty()`

### getPrefWrapLength

public final double getPrefWrapLength()
Gets the value of the `prefWrapLength` property.

Property description:
  The preferred width where content should wrap in a horizontal flowpane or the preferred height where content should wrap in a vertical flowpane.

  This value is used only to compute the preferred size of the flowpane and may not reflect the actual width or height, which may change if the flowpane is resized to something other than its preferred size.

  Applications should initialize this value to define a reasonable span for wrapping the content.

Returns:
  the value of the `prefWrapLength` property
See Also:
  - `setPrefWrapLength(double)`
  - `prefWrapLengthProperty()`

### alignmentProperty

public final ObjectProperty<Pos> alignmentProperty()
The overall alignment of the flowpane's content within its width and height.

For a horizontal flowpane, each row will be aligned within the flowpane's width using the alignment's hpos value, and the rows will be aligned within the flowpane's height using the alignment's vpos value.

For a vertical flowpane, each column will be aligned within the flowpane's height using the alignment's vpos value, and the columns will be aligned within the flowpane's width using the alignment's hpos value.

Returns:
  the overall alignment of the flowpane's content within its width and height
See Also:
  - `getAlignment()`
  - `setAlignment(Pos)`

### setAlignment

public final void setAlignment(Pos value)
Sets the value of the `alignment` property.

Property description:
  The overall alignment of the flowpane's content within its width and height.

  For a horizontal flowpane, each row will be aligned within the flowpane's width using the alignment's hpos value, and the rows will be aligned within the flowpane's height using the alignment's vpos value.

  For a vertical flowpane, each column will be aligned within the flowpane's height using the alignment's vpos value, and the columns will be aligned within the flowpane's width using the alignment's hpos value.

Parameters:
  `value` - the value for the `alignment` property
See Also:
  - `getAlignment()`
  - `alignmentProperty()`

### getAlignment

public final Pos getAlignment()
Gets the value of the `alignment` property.

Property description:
  The overall alignment of the flowpane's content within its width and height.

  For a horizontal flowpane, each row will be aligned within the flowpane's width using the alignment's hpos value, and the rows will be aligned within the flowpane's height using the alignment's vpos value.

  For a vertical flowpane, each column will be aligned within the flowpane's height using the alignment's vpos value, and the columns will be aligned within the flowpane's width using the alignment's hpos value.

Returns:
  the value of the `alignment` property
See Also:
  - `setAlignment(Pos)`
  - `alignmentProperty()`

### columnHalignmentProperty

public final ObjectProperty<HPos> columnHalignmentProperty()
The horizontal alignment of nodes within each column of a vertical flowpane. The property is ignored for horizontal flowpanes.

Returns:
  the horizontal alignment of nodes within each column of a vertical flowpane
See Also:
  - `getColumnHalignment()`
  - `setColumnHalignment(HPos)`

### setColumnHalignment

public final void setColumnHalignment(HPos value)
Sets the value of the `columnHalignment` property.

Property description:
  The horizontal alignment of nodes within each column of a vertical flowpane. The property is ignored for horizontal flowpanes.
Parameters:
  `value` - the value for the `columnHalignment` property
See Also:
  - `getColumnHalignment()`
  - `columnHalignmentProperty()`

### getColumnHalignment

public final HPos getColumnHalignment()
Gets the value of the `columnHalignment` property.

Property description:
  The horizontal alignment of nodes within each column of a vertical flowpane. The property is ignored for horizontal flowpanes.
Returns:
  the value of the `columnHalignment` property
See Also:
  - `setColumnHalignment(HPos)`
  - `columnHalignmentProperty()`

### rowValignmentProperty

public final ObjectProperty<VPos> rowValignmentProperty()
The vertical alignment of nodes within each row of a horizontal flowpane. If this property is set to VPos.BASELINE, then the flowpane will always resize children to their preferred heights, rather than expanding heights to fill the row height. The property is ignored for vertical flowpanes.

Returns:
  the vertical alignment of nodes within each row of a horizontal flowpane
See Also:
  - `getRowValignment()`
  - `setRowValignment(VPos)`

### setRowValignment

public final void setRowValignment(VPos value)
Sets the value of the `rowValignment` property.

Property description:
  The vertical alignment of nodes within each row of a horizontal flowpane. If this property is set to VPos.BASELINE, then the flowpane will always resize children to their preferred heights, rather than expanding heights to fill the row height. The property is ignored for vertical flowpanes.
Parameters:
  `value` - the value for the `rowValignment` property
See Also:
  - `getRowValignment()`
  - `rowValignmentProperty()`

### getRowValignment

public final VPos getRowValignment()
Gets the value of the `rowValignment` property.

Property description:
  The vertical alignment of nodes within each row of a horizontal flowpane. If this property is set to VPos.BASELINE, then the flowpane will always resize children to their preferred heights, rather than expanding heights to fill the row height. The property is ignored for vertical flowpanes.
Returns:
  the value of the `rowValignment` property
See Also:
  - `setRowValignment(VPos)`
  - `rowValignmentProperty()`

### getContentBias

public Orientation getContentBias()
Description copied from class: `Node`
Returns the orientation of a node's resizing bias for layout purposes. If the node type has no bias, returns null. If the node is resizable and it's height depends on its width, returns HORIZONTAL, else if its width depends on its height, returns VERTICAL.

Resizable subclasses should override this method to return an appropriate value.

Overrides:
  `getContentBias` in class `Node`
Returns:
  orientation of width/height dependency or null if there is none
See Also:
  - `Node.isResizable()`
  - `Node.minWidth(double)`
  - `Node.minHeight(double)`
  - `Node.prefWidth(double)`
  - `Node.prefHeight(double)`
  - `Node.maxWidth(double)`
  - `Node.maxHeight(double)`

### computeMinWidth

protected double computeMinWidth(double height)
Description copied from class: `Region`
Computes the minimum width of this region. Returns the sum of the left and right insets by default. region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a VERTICAL content bias, then the height parameter can be ignored.

Overrides:
  `computeMinWidth` in class `Region`
Parameters:
  `height` - the height that should be used if min width depends on it
Returns:
  the computed minimum width of this region

### computeMinHeight

protected double computeMinHeight(double width)
Description copied from class: `Region`
Computes the minimum height of this region. Returns the sum of the top and bottom insets by default. Region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a HORIZONTAL content bias, then the width parameter can be ignored.

Overrides:
  `computeMinHeight` in class `Region`
Parameters:
  `width` - the width that should be used if min height depends on it
Returns:
  the computed minimum height for this region

### computePrefWidth

protected double computePrefWidth(double forHeight)
Description copied from class: `Region`
Computes the preferred width of this region for the given height. Region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a VERTICAL content bias, then the height parameter can be ignored.

Overrides:
  `computePrefWidth` in class `Region`
Parameters:
  `forHeight` - the height that should be used if preferred width depends on it
Returns:
  the computed preferred width for this region

### computePrefHeight

protected double computePrefHeight(double forWidth)
Description copied from class: `Region`
Computes the preferred height of this region for the given width; Region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a HORIZONTAL content bias, then the width parameter can be ignored.

Overrides:
  `computePrefHeight` in class `Region`
Parameters:
  `forWidth` - the width that should be used if preferred height depends on it
Returns:
  the computed preferred height for this region

### requestLayout

public void requestLayout()
Description copied from class: `Parent`
Requests a layout pass to be performed before the next scene is rendered. This is batched up asynchronously to happen once per "pulse", or frame of animation.

If this parent is either a layout root or unmanaged, then it will be added directly to the scene's dirty layout list, otherwise requestParentLayout will be invoked.

Overrides:
  `requestLayout` in class `Parent`

### layoutChildren

protected void layoutChildren()
Description copied from class: `Parent`
Invoked during the layout pass to layout the children in this `Parent`. By default it will only set the size of managed, resizable content to their preferred sizes and does not do any node positioning.

Subclasses should override this function to layout content as needed.

Overrides:
  `layoutChildren` in class `Parent`

### getClassCssMetaData

public static List<CssMetaData<? extends Styleable,?>> getClassCssMetaData()

Returns:
  The CssMetaData associated with this class, which may include the CssMetaData of its superclasses.
Since:
  JavaFX 8.0

### getCssMetaData

public List<CssMetaData<? extends Styleable,?>> getCssMetaData()
This method should delegate to `Node.getClassCssMetaData()` so that a Node's CssMetaData can be accessed without the need for reflection.

Specified by:
  `getCssMetaData` in interface `Styleable`
Overrides:
  `getCssMetaData` in class `Region`
Returns:
  The CssMetaData associated with this node, which may include the CssMetaData of its superclasses.
Since:
  JavaFX 8.0